# Cinder

# cinder::gl::VboMesh::Layout Struct Reference

`#include <Vbo.h>`

List of all members.

## Public Types
enum | CustomAttr { CUSTOM_ATTR_FLOAT, CUSTOM_ATTR_FLOAT2, CUSTOM_ATTR_FLOAT3, CUSTOM_ATTR_FLOAT4, TOTAL_CUSTOM_ATTR_TYPES }
## Public Member Functions
| Layout ()
bool | isDefaults () const
bool | hasNormals () const
bool | hasStaticNormals () const
bool | hasDynamicNormals () const
void | setStaticNormals ()
void | setDynamicNormals ()
bool | hasColorsRGB () const
bool | hasStaticColorsRGB () const
bool | hasDynamicColorsRGB () const
void | setStaticColorsRGB ()
void | setDynamicColorsRGB ()
bool | hasColorsRGBA () const
bool | hasStaticColorsRGBA () const
bool | hasDynamicColorsRGBA () const
void | setStaticColorsRGBA ()
void | setDynamicColorsRGBA ()
bool | hasTexCoords2d (size_t unit=0) const
bool | hasStaticTexCoords2d (size_t unit=0) const
bool | hasDynamicTexCoords2d (size_t unit=0) const
void | setStaticTexCoords2d (size_t unit=0)
void | setDynamicTexCoords2d (size_t unit=0)
bool | hasStaticTexCoords () const
bool | hasDynamicTexCoords () const
bool | hasTexCoords (size_t unit) const
bool | hasTexCoords3d (size_t unit=0) const
bool | hasStaticTexCoords3d (size_t unit=0) const
bool | hasDynamicTexCoords3d (size_t unit=0) const
void | setStaticTexCoords3d (size_t unit=0)
void | setDynamicTexCoords3d (size_t unit=0)
bool | hasIndices () const
bool | hasStaticIndices () const
bool | hasDynamicIndices () const
void | setStaticIndices ()
void | setDynamicIndices ()
bool | hasPositions () const
bool | hasStaticPositions () const
bool | hasDynamicPositions () const
void | setStaticPositions ()
void | setDynamicPositions ()
void | addDynamicCustomFloat ()
void | addDynamicCustomVec2f ()
void | addDynamicCustomVec3f ()
void | addDynamicCustomVec4f ()
## Public Attributes
int | mAttributes [ATTR_TOTAL]
std::vector< std::pair < CustomAttr, size_t > > | mCustomDynamic
std::vector< std::pair < CustomAttr, size_t > > | mCustomStatic
## Static Public Attributes
static int | sCustomAttrSizes [TOTAL_CUSTOM_ATTR_TYPES] = { 4, 8, 12, 16 }
static GLint | sCustomAttrNumComponents [TOTAL_CUSTOM_ATTR_TYPES] = { 1, 2, 3, 4 }
static GLenum | sCustomAttrTypes [TOTAL_CUSTOM_ATTR_TYPES] = { GL_FLOAT, GL_FLOAT, GL_FLOAT, GL_FLOAT }

## Member Enumeration Documentation

enum cinder::gl::VboMesh::Layout::CustomAttr

Enumerator:

  CUSTOM_ATTR_FLOAT |
  CUSTOM_ATTR_FLOAT2 |
  CUSTOM_ATTR_FLOAT3 |
  CUSTOM_ATTR_FLOAT4 |
  TOTAL_CUSTOM_ATTR_TYPES |

## Constructor & Destructor Documentation

cinder::gl::VboMesh::Layout::Layout | ( |  | ) |

## Member Function Documentation

bool cinder::gl::VboMesh::Layout::isDefaults | ( |  | ) | const

Returns:
  is the Layout unspecified, presumably TBG by a constructor for VboMesh

bool cinder::gl::VboMesh::Layout::hasNormals | ( |  | ) | const

bool cinder::gl::VboMesh::Layout::hasStaticNormals | ( |  | ) | const

bool cinder::gl::VboMesh::Layout::hasDynamicNormals | ( |  | ) | const

void cinder::gl::VboMesh::Layout::setStaticNormals | ( |  | ) |

void cinder::gl::VboMesh::Layout::setDynamicNormals | ( |  | ) |

bool cinder::gl::VboMesh::Layout::hasColorsRGB | ( |  | ) | const

bool cinder::gl::VboMesh::Layout::hasStaticColorsRGB | ( |  | ) | const

bool cinder::gl::VboMesh::Layout::hasDynamicColorsRGB | ( |  | ) | const

void cinder::gl::VboMesh::Layout::setStaticColorsRGB | ( |  | ) |

void cinder::gl::VboMesh::Layout::setDynamicColorsRGB | ( |  | ) |

bool cinder::gl::VboMesh::Layout::hasColorsRGBA | ( |  | ) | const

bool cinder::gl::VboMesh::Layout::hasStaticColorsRGBA | ( |  | ) | const

bool cinder::gl::VboMesh::Layout::hasDynamicColorsRGBA | ( |  | ) | const

void cinder::gl::VboMesh::Layout::setStaticColorsRGBA | ( |  | ) |

void cinder::gl::VboMesh::Layout::setDynamicColorsRGBA | ( |  | ) |

bool cinder::gl::VboMesh::Layout::hasTexCoords2d | ( | size_t | unit = `0` | ) | const

bool cinder::gl::VboMesh::Layout::hasStaticTexCoords2d | ( | size_t | unit = `0` | ) | const

bool cinder::gl::VboMesh::Layout::hasDynamicTexCoords2d | ( | size_t | unit = `0` | ) | const

void cinder::gl::VboMesh::Layout::setStaticTexCoords2d | ( | size_t | unit = `0` | ) |

void cinder::gl::VboMesh::Layout::setDynamicTexCoords2d | ( | size_t | unit = `0` | ) |

bool cinder::gl::VboMesh::Layout::hasStaticTexCoords | ( |  | ) | const

Returns:
  are there any texture units with static texCoords

bool cinder::gl::VboMesh::Layout::hasDynamicTexCoords | ( |  | ) | const

Returns:
  are there any texture units with dynamic texCoords

bool cinder::gl::VboMesh::Layout::hasTexCoords | ( | size_t | unit | ) | const

Returns:
  if texture unit
  - unit is enabled

bool cinder::gl::VboMesh::Layout::hasTexCoords3d | ( | size_t | unit = `0` | ) | const

bool cinder::gl::VboMesh::Layout::hasStaticTexCoords3d | ( | size_t | unit = `0` | ) | const

bool cinder::gl::VboMesh::Layout::hasDynamicTexCoords3d | ( | size_t | unit = `0` | ) | const

void cinder::gl::VboMesh::Layout::setStaticTexCoords3d | ( | size_t | unit = `0` | ) |

void cinder::gl::VboMesh::Layout::setDynamicTexCoords3d | ( | size_t | unit = `0` | ) |

bool cinder::gl::VboMesh::Layout::hasIndices | ( |  | ) | const

bool cinder::gl::VboMesh::Layout::hasStaticIndices | ( |  | ) | const

bool cinder::gl::VboMesh::Layout::hasDynamicIndices | ( |  | ) | const

void cinder::gl::VboMesh::Layout::setStaticIndices | ( |  | ) |

void cinder::gl::VboMesh::Layout::setDynamicIndices | ( |  | ) |

bool cinder::gl::VboMesh::Layout::hasPositions | ( |  | ) | const

bool cinder::gl::VboMesh::Layout::hasStaticPositions | ( |  | ) | const

bool cinder::gl::VboMesh::Layout::hasDynamicPositions | ( |  | ) | const

void cinder::gl::VboMesh::Layout::setStaticPositions | ( |  | ) |

void cinder::gl::VboMesh::Layout::setDynamicPositions | ( |  | ) |

void cinder::gl::VboMesh::Layout::addDynamicCustomFloat | ( |  | ) |

void cinder::gl::VboMesh::Layout::addDynamicCustomVec2f | ( |  | ) |

void cinder::gl::VboMesh::Layout::addDynamicCustomVec3f | ( |  | ) |

void cinder::gl::VboMesh::Layout::addDynamicCustomVec4f | ( |  | ) |

## Member Data Documentation

int cinder::gl::VboMesh::Layout::sCustomAttrSizes = { 4, 8, 12, 16 }`[static]`

GLint cinder::gl::VboMesh::Layout::sCustomAttrNumComponents = { 1, 2, 3, 4 }`[static]`

GLenum cinder::gl::VboMesh::Layout::sCustomAttrTypes = { GL_FLOAT, GL_FLOAT, GL_FLOAT, GL_FLOAT }`[static]`

int cinder::gl::VboMesh::Layout::mAttributes[ATTR_TOTAL]

std::vector<std::pair<CustomAttr,size_t> > cinder::gl::VboMesh::Layout::mCustomDynamic

std::vector<std::pair<CustomAttr,size_t> > cinder::gl::VboMesh::Layout::mCustomStatic

The documentation for this struct was generated from the following files:

- include/cinder/gl/Vbo.h
- src/cinder/gl/Vbo.cpp